/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package du10;

/**
 *
 * @author votavon1
 */
public class Main {
    private static boolean isOteviraciZavorka(char znak){
        switch(znak){
            case '(':
            case '{':
            case '[':
                return true;
        }
        return false;
    }

    private static boolean isZaviraciZavorka(char znak){
        switch(znak){
            case ')':
            case '}':
            case ']':
                return true;
        }
        return false;
    }

    private static boolean isZavorka(char znak){
        switch(znak){
            case '(':
            case '{':
            case '[':
            case ')':
            case '}':
            case ']':
                return true;
        }
        return false;
    }

    private static char odpovidajiciZavorka(char znak){
        char z = 0;
        switch(znak){
            case ')': z = '('; break;
            case '}': z = '{'; break;
            case ']': z = '['; break;
        }
        return z;
    }


    
    public static boolean spravneOzavorkovan(String vyraz){
        Zasobnik z = new Zasobnik();
        for (int i= 0; i < vyraz.length(); i++) {
            char znak = vyraz.charAt(i);
            if(isZavorka(znak)){
                if(isOteviraciZavorka(znak)){
                    z.push(znak);
                    continue;
                }
                if(isZaviraciZavorka(znak)){
                    if(odpovidajiciZavorka(znak) != z.pop()){
                        return false;
                    }
                }
            }
        }
        if(z.ukazatel > 0) return false;
        return true;
    }
    
    
    public static void main(String[] args) {
        // TODO code application logic here
        System.out.println(spravneOzavorkovan("(abc(def)ghi)"));
        System.out.println(spravneOzavorkovan("(abc[def)ghi)"));
        System.out.println(spravneOzavorkovan("(abc{def}ghi))"));
        System.out.println(spravneOzavorkovan("{abc(def}ghi)"));
        System.out.println(spravneOzavorkovan("[][][](())(())abc{def(ghi)}"));
    }

}
